print "Content-type: text/html\n\n";

# filename:  del_dir.cgi
# type:      perl program
# last rev:  18.08.98
# author:    Bjarni Thor Pjetursson
# email:     pjetursson@hotmail.com
#
# Description:
# Part of the FileTrans System.
# Developed for WWW and only works in conjunction with the other parts.
#
# The following code is divided into parts:
# var def, var import, var manipulation, control, altering, deletion, output

# VAR DEF:
$REASON = "del_dir.cgi";
require "main.cgi";


# VAR IMPORT:
#
$cgi_lib'maxdata = 100;                   # max input accepted by cgi-lib.pl
require "misc.cgi";
$ret           = &ReadParse;
$DIRNAME       = $in{'dirname'};


# VAR MANIPULATION:
#
if ($DIRNAME =~ /(\w+)\.(\w+)/i) {$DIRNAME = "$1.$2";}
else {$DIRNAME =~ /(\w+)/i;
$DIRNAME = "$1";}                         # DIRNAME now cleaned for meta chars
$PATH_DIRNAME  = "$FULL_PATH/$DIRNAME";   # full path incl. dir name


# CONTROL:
#
# Browser input control:
&CgiDie("No name specified - try again") if !$DIRNAME;
&CgiDie("Sorry, $PATH_DIRNAME not found - try again") unless -d $PATH_DIRNAME;

#
# Lib control:
$tom_test     = `ls $PATH_DIRNAME`;
$tom_test     =~ s/del_dir.html//;        # replace: s/this/replaced by this/
$tom_test     =~ s/del_file.html//;
$tom_test     =~ s/files.html//;
$tom_test     =~ s/make_dir.html//;
$tom_test     =~ s/upload.html//;
$tom_test     =~ s/leftcell.html//;
$tom_test     =~ s/index.html//;
$tom_test     =~ s/(\s+)//g;
$tom_test     =~ s/(\n+)//g;
$tom_test     =~ s/(\r+)//g;
$tom_test     =~ s/(\f+)//g;
#
# Die if lib not empty or dir not found:
&CgiDie("Sorry, $DIRNAME not empty") if $tom_test;
&CgiDie("Sorry, $PATH_DIRNAME not found") unless -e $PATH_DIRNAME;
#
#
# ALTERING/DELETION:
#
############# files.html is altered: #############
open (CONTENTS, "< $FULL_PATH/files.html") || &CgiDie ("Couldn't open files.html\n");
open (CONTENTS_TMP, ">> $FULL_PATH/files.temp") || &CgiDie ("Couldn't open temp file\n");
$CONTENTS = <CONTENTS>;
print CONTENTS_TMP "$CONTENTS";

LOOP:
while ($CONTENTS = <CONTENTS>) {
  print CONTENTS_TMP "$CONTENTS";
  unless ($CONTENTS =~ /\<! DIR-START\>/i) {next LOOP};
  while (!$YES) {
     $CONTENTS1 = <CONTENTS>;
     unless ($CONTENTS1 =~ /\<TABLE/i)
       {print CONTENTS_TMP "$CONTENTS1";
       next LOOP};
     $CONTENTS2 = <CONTENTS>;
     $CONTENTS3 = <CONTENTS>;
     $CONTENTS4 = <CONTENTS>;
     $CONTENTS5 = <CONTENTS>;
     $CONTENTS6 = <CONTENTS>;
     $CONTENTS7 = <CONTENTS>;
     $CONTENTS8 = <CONTENTS>;
     if ($CONTENTS3 =~ /\>$DIRNAME\</i) {
        $YES = "yes";
        # Lib found, deletion may proceed
        print `rm $PATH_DIRNAME/*`;
        print `rm $PATH_DIRNAME/.htaccess`;
        print `rmdir $PATH_DIRNAME`;
        next LOOP}
     print CONTENTS_TMP "$CONTENTS1";
     print CONTENTS_TMP "$CONTENTS2";
     print CONTENTS_TMP "$CONTENTS3";
     print CONTENTS_TMP "$CONTENTS4";
     print CONTENTS_TMP "$CONTENTS5";
     print CONTENTS_TMP "$CONTENTS6";
     print CONTENTS_TMP "$CONTENTS7";
     print CONTENTS_TMP "$CONTENTS8";
  }
}

print `mv $FULL_PATH/files.temp $FULL_PATH/files.html`;
&CgiDie("Sorry, directory not found - try again") if !$YES;
flock (CONTENTS, 8);
flock (CONTENTS_TMP, 8);
close CONTENTS;
close CONTENTS_TMP;

# OUTPUT TO BROWSER:
#
print <<WEB_PAGE;
<html>
<body text="#000080" bgcolor="#FFFFFF" link="#0000EE" vlink="#551A8B" alink="#FF0000"
onLoad="parent.bodycell.location.href='$FULL_URL/files.html'; return true;">
<BR>
<h3><center>$DIRNAME deleted
</center>
</body>
</html>
WEB_PAGE
