print "Content-type: text/html\n\n";

# file name: upload.cgi
# type:      perl program
# last rev:  18.08.1998
# author:    Bjarni Thor Pjetursson
# email:     pjetursson@hotmail.com
#
# Description:
# Part of the FileTrans System
# Developed for WWW and only works in conjunction with the other parts
#
# The following code is divided into parts:
# var def, var import, var manipulation, control, altering, output


# VAR DEF:
#
$REASON = "upload.cgi";
require "main.cgi";


# VAR IMPORT:
#
$cgi_lib'writefiles = $FULL_PATH;          # we tell cgi-lib.pl where to write the file
$cgi_lib'maxdata = $UPLOAD_SIZE;           # max allowed file size
require "misc.cgi";
$ret = &ReadParse;
$NOTE          = $in{'note'};


# VAR MANIPULATION:
#
$NOTE          =~ s/</&lt\;/g;            # the form input is changed to html format
$NOTE          =~ s/>/&gt\;/g;
$NOTE          =~ s//&aelig\;/g;
$NOTE          =~ s//&AElig\;/g;
$NOTE          =~ s//&oslash\;/g;
$NOTE          =~ s//&Oslash\;/g;
$NOTE          =~ s//&aring\;/g;
$NOTE          =~ s//&Aring\;/g;
$NOTE          =~ s//&uml\;/g;
$NOTE          =~ s/"/&quot\;/g;
$NOTE          =~ s//&curren\;/g;
# $NOTE          =~ s/&/&amp\;/g; ### done by cgi-lib.pl
$NOTE          =~ s//&acute\;/g;
$NOTE          =~ s//&pound\;/g;
$NOTE          =~ s//&frac12\;/g;
$NOTE          =~ s//&sect\;/g;
$LEN           = -s $FULL_PATH."/".$FILENAME; # size of the file


# CONTROL:
#
&CgiDie("Sorry, your browser does not support file upload") unless $TYPE =~ /multipart/i;


# ALTERING:
#
########### files.html is being altered: ############
open (CONTENTS, "< $FULL_PATH/files.html") || &CgiDie ("Couldn't open files.html");
open (CONTENTS_TMP, ">> $FULL_PATH/files.temp") || &CgiDie ("Couldn't open temp file");
flock (CONTENTS, 2);
flock (CONTENTS_TMP, 2);

$CONTENTS = <CONTENTS>;
print CONTENTS_TMP "$CONTENTS";

LOOP:
while ($CONTENTS = <CONTENTS>)
{$CONTENTS =~ s/\<! FILE-START\>/\<! FILE-START\>
\<CENTER\>\<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=0 WIDTH=100%\>\<TR\>
\<TD WIDTH=5%\>\<A HREF=$FILENAME\>\<IMG SRC=$PIXELS_URL\/transfer.gif HEIGHT=22 WIDTH=20 BORDER=0\>\<\/A\>\<\/TD\>
\<TD WIDTH=50%\>\<A HREF=$FILENAME\>$FILENAME\<\/A\>\<BR\>
\<I\>$NOTE\<\/I\>\<\/TD\>\<TD WIDTH=5%\>\<\/TD\>
\<TD WIDTH=20%\>$MTH $DD $YEAR\<\/TD\>
\<TD WIDTH=20%\>$REMOTE_HOST\/\<BR\>
$LEN bytes\<\/TD\>
\<\/TR\>\<\/TABLE\>\<\/CENTER\>
/i;

print CONTENTS_TMP "$CONTENTS";
next LOOP;}

print `mv $FULL_PATH/files.temp $FULL_PATH/files.html`;
flock (CONTENTS, 8);
flock (CONTENTS_TMP, 8);
close CONTENTS;
close CONTENTS_TMP;

# OUTPUT TO BROWSEREN:
#
print <<WEB_PAGE;
<html>
<body text="#000080" bgcolor="#FFFFFF" link="#0000EE" vlink="#551A8B" alink="#FF0000"
onLoad="parent.bodycell.location.href='$FULL_URL/files.html'; return true;">
<BR>
<center><H3>$FILENAME uploaded
</center>
</body>
</html>
WEB_PAGE
